import ctypes
import sys

from PySide6.QtWidgets import QApplication
from vtkmodules.vtkCommonCore import vtkFileOutputWindow, vtkOutputWindow

from crystalfly.ui.main_window import MainWindow

ctypes.windll.shell32.SetCurrentProcessExplicitAppUserModelID("crystalfly")


def main():
    app = QApplication(sys.argv)
    window = MainWindow()
    window.show()
    sys.exit(app.exec())


if __name__ == '__main__':
    # pipe vtk output errors to file
    errOut = vtkFileOutputWindow()
    errOut.SetFileName("VTK Error Out.txt")
    vtkStdErrOut = vtkOutputWindow()
    vtkStdErrOut.SetInstance(errOut)
    main()
