import sys

from PySide6.QtCore import QThread, Signal, Slot
from PySide6.QtWidgets import QWidget, QPushButton, QApplication, QLabel, QVBoxLayout
from vtkmodules.vtkIOImage import vtkImageReader2


class TestThread(QThread):
    timeSignal = Signal(str)

    def __init__(self):
        super().__init__()

    def run(self):
        reader = vtkImageReader2()
        reader.SetFileName("D:/Downloads/christmas_tree_512x499x512_uint16.raw")
        reader.SetFileDimensionality(3)
        reader.SetDataSpacing(0.1, 0.1, 0.1)
        reader.SetDataExtent(0, 511, 0, 498, 0, 511)
        reader.SetDataScalarTypeToUnsignedShort()
        reader.Update()
        self.timeSignal.emit("success")
        # for i in range(10):
        #     print(i)
        #     self.timeSignal.emit(str(i))
        #     time.sleep(1)


class MainView(QWidget):
    def __init__(self):
        super().__init__()
        self.resize(800, 600)
        self.test_thread = TestThread()
        main_layout = QVBoxLayout()
        self.label = QLabel("0")
        self.button = QPushButton('TEST')
        self.button.clicked.connect(self.button_clicked)
        main_layout.addWidget(self.label)
        main_layout.addWidget(self.button)
        self.setLayout(main_layout)
        self.test_thread.timeSignal.connect(self.label.setText)

    @Slot()
    def button_clicked(self):
        self.test_thread.start()


if __name__ == '__main__':
    app = QApplication(sys.argv)
    window = MainView()
    window.show()
    app.exec()
