from typing import Any

from PySide6.QtCore import QThread, Signal
from vtkmodules.vtkIOImage import vtkMedicalImageReader2

from crystalfly.model.image_reader import image_reader_model


# from vtkmodules.vtkCommonCore import vtkCommand, VTK_INT

class ImageReaderThread(QThread):
    loadedSignal = Signal(Any)

    def __init__(self, file_data, parent=None):
        QThread.__init__(self, parent)
        self.file_data = file_data

    def run(self):
        reader = vtkMedicalImageReader2()
        reader.SetFileName(self.file_data["file_path"])
        reader.SetFileDimensionality(3)
        reader.SetDataSpacing(0.1, 0.1, 0.1)
        print(self.file_data)
        reader.SetDataExtent(
            0,
            self.file_data["size"]["x"] - 1,
            0,
            self.file_data["size"]["y"] - 1,
            0,
            self.file_data["size"]["z"] - 1,
        )
        # self.file_data["data_type"]
        reader.SetDataScalarType(self.file_data["data_type"])
        reader.Update()
        image_reader_model.loaded(reader.GetOutput())
        print("success")
